/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "ballonconfiguration.h"


////@begin XPM images
////@end XPM images
#include "SimpleShapeDrawerDialog.h"
#include "SimpleShapeDrawer.h"

/*!
 * CBallonConfiguration type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CBallonConfiguration, wxMDIChildFrame )


/*!
 * CBallonConfiguration event table definition
 */

BEGIN_EVENT_TABLE( CBallonConfiguration, wxMDIChildFrame )

////@begin CBallonConfiguration event table entries
    EVT_CLOSE( CBallonConfiguration::OnCloseWindow )
    EVT_WINDOW_DESTROY( CBallonConfiguration::OnDestroy )

    EVT_CHECKBOX( ID_CHECKBOX_AUTOSENSITIVY, CBallonConfiguration::OnCheckboxAutosensitivyClick )

    EVT_SLIDER( ID_SLIDER_SENSITIVY, CBallonConfiguration::OnSliderSensitivyUpdated )

    EVT_BUTTON( ID_BUTTON, CBallonConfiguration::OnButtonPreviousStageClick )

    EVT_BUTTON( ID_BUTTON1, CBallonConfiguration::OnButtonNextStageClick )

    EVT_SLIDER( ID_SLIDER_SMOOTHING, CBallonConfiguration::OnSliderSmoothingUpdated )

    EVT_SLIDER( ID_SLIDER_BASE_FREQ, CBallonConfiguration::OnSliderBaseFreqUpdated )

    EVT_SLIDER( ID_SLIDER_FREQ_RANGE, CBallonConfiguration::OnSliderFreqRangeUpdated )

    EVT_COLOURPICKER_CHANGED( ID_COLOURCTRL_BACKGROUND, CBallonConfiguration::OnColourctrlBackgroundColourPickerChanged )

    EVT_COLOURPICKER_CHANGED( ID_COLOURCTRL_DRAWING, CBallonConfiguration::OnColourctrlDrawingColourPickerChanged )

////@end CBallonConfiguration event table entries

	EVT_TIMER(TIMER_ID, CBallonConfiguration::OnTimer)

END_EVENT_TABLE()

CBallonConfiguration* CBallonConfiguration::g_single= NULL;
CBallonConfiguration* CBallonConfiguration::getInstance(wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style)
{
	if (g_single== NULL) {
		g_single= new CBallonConfiguration( parent, id, caption, pos, size, style);
	}
	return g_single;
}
	


/*!
 * CBallonConfiguration constructors
 */

CBallonConfiguration::CBallonConfiguration()
: m_timer(this, TIMER_ID) //, m_simpleShapeDrawer(NULL)
{
    Init();
}

/*
CBallonConfiguration::CBallonConfiguration(CBallonActivity* activity, CSimpleShapeDrawer* ssd) 
: m_activity(activity), m_timer(this, TIMER_ID), m_simpleShapeDrawer(ssd)
{
	Init();
}*/

//CBallonConfiguration::CBallonConfiguration( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
CBallonConfiguration::CBallonConfiguration( wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style)
:  m_timer(this, TIMER_ID) //, m_simpleShapeDrawer(NULL)m_activity(NULL),
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * BallonConfiguration creator
 */



//bool CBallonConfiguration::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
bool CBallonConfiguration::Create( wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style)
{
////@begin CBallonConfiguration creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxMDIChildFrame::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
////@end CBallonConfiguration creation
    return true;
}


/*!
 * CBallonConfiguration destructor
 */

CBallonConfiguration::~CBallonConfiguration()
{
	CBallonConfiguration::g_single= NULL;
////@begin CBallonConfiguration destruction
////@end CBallonConfiguration destruction
}


/*!
 * Member initialisation
 */

void CBallonConfiguration::Init()
{
////@begin CBallonConfiguration member initialisation
    m_chkAutoSensitivy = NULL;
    m_sldSensitivy = NULL;
    m_txtSensitivy = NULL;
    m_btnPrevStage = NULL;
    m_txtCurrentStage = NULL;
    m_btnNextStage = NULL;
    m_sldSmoothing = NULL;
    m_txtSmoothing = NULL;
    m_sldBaseFreq = NULL;
    m_txtBaseFrequency = NULL;
    m_sldFreqRange = NULL;
    m_txtFreqRange = NULL;
    m_clrctrlBackground = NULL;
    m_clrctrlDrawing = NULL;
////@end CBallonConfiguration member initialisation
}


/*!
 * Control creation for BallonConfiguration
 */

void CBallonConfiguration::CreateControls()
{    
////@begin CBallonConfiguration content construction
    CBallonConfiguration* itemMDIChildFrame1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemMDIChildFrame1->SetSizer(itemBoxSizer2);

    wxPanel* itemPanel3 = new wxPanel;
    itemPanel3->Create( itemMDIChildFrame1, ID_PANEL1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemBoxSizer2->Add(itemPanel3, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 0);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxVERTICAL);
    itemPanel3->SetSizer(itemBoxSizer4);

    wxStaticBox* itemStaticBoxSizer5Static = new wxStaticBox(itemPanel3, wxID_ANY, _("Sensitivy"));
    wxStaticBoxSizer* itemStaticBoxSizer5 = new wxStaticBoxSizer(itemStaticBoxSizer5Static, wxVERTICAL);
    itemBoxSizer4->Add(itemStaticBoxSizer5, 0, wxALIGN_LEFT|wxALL, 5);

    m_chkAutoSensitivy = new wxCheckBox;
    m_chkAutoSensitivy->Create( itemPanel3, ID_CHECKBOX_AUTOSENSITIVY, _("Automatic"), wxDefaultPosition, wxDefaultSize, 0 );
    m_chkAutoSensitivy->SetValue(false);
    itemStaticBoxSizer5->Add(m_chkAutoSensitivy, 0, wxALIGN_LEFT|wxALL, 5);

    wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer5->Add(itemBoxSizer7, 0, wxALIGN_LEFT|wxALL, 0);

    m_sldSensitivy = new wxSlider;
    m_sldSensitivy->Create( itemPanel3, ID_SLIDER_SENSITIVY, 0, 1, 100, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemBoxSizer7->Add(m_sldSensitivy, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    m_txtSensitivy = new wxStaticText;
    m_txtSensitivy->Create( itemPanel3, wxID_STATIC, _("000.0"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer7->Add(m_txtSensitivy, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    CSimpleShapeDrawerDialog* itemPanel10 = new CSimpleShapeDrawerDialog( m_activity.getSimpleShapeDrawer() );
    itemPanel10->Create( itemPanel3, ID_PANEL, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL  );
    itemBoxSizer4->Add(itemPanel10, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer11Static = new wxStaticBox(itemPanel3, wxID_ANY, _("Current stage"));
    wxStaticBoxSizer* itemStaticBoxSizer11 = new wxStaticBoxSizer(itemStaticBoxSizer11Static, wxVERTICAL);
    itemBoxSizer4->Add(itemStaticBoxSizer11, 0, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer12 = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer11->Add(itemBoxSizer12, 0, wxGROW|wxALL, 0);

    m_btnPrevStage = new wxButton;
    m_btnPrevStage->Create( itemPanel3, ID_BUTTON, _("<"), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT );
    m_btnPrevStage->SetName(_T("PrevStage"));
    itemBoxSizer12->Add(m_btnPrevStage, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_txtCurrentStage = new wxTextCtrl;
    m_txtCurrentStage->Create( itemPanel3, ID_TEXTCTRL, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_CENTRE );
    itemBoxSizer12->Add(m_txtCurrentStage, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_btnNextStage = new wxButton;
    m_btnNextStage->Create( itemPanel3, ID_BUTTON1, _(">"), wxDefaultPosition, wxSize(25, -1), wxBU_EXACTFIT );
    m_btnNextStage->SetName(_T("NextStage"));
    itemBoxSizer12->Add(m_btnNextStage, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText16 = new wxStaticText;
    itemStaticText16->Create( itemPanel3, wxID_STATIC, _("Smoothing"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText16, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer17 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer4->Add(itemBoxSizer17, 0, wxALIGN_LEFT|wxALL, 5);

    m_sldSmoothing = new wxSlider;
    m_sldSmoothing->Create( itemPanel3, ID_SLIDER_SMOOTHING, 0, 0, 100, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemBoxSizer17->Add(m_sldSmoothing, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_txtSmoothing = new wxStaticText;
    m_txtSmoothing->Create( itemPanel3, wxID_STATIC, _("000.0"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer17->Add(m_txtSmoothing, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText20 = new wxStaticText;
    itemStaticText20->Create( itemPanel3, wxID_STATIC, _("Base frequency "), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText20->Show(false);
    itemBoxSizer4->Add(itemStaticText20, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer21 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer4->Add(itemBoxSizer21, 0, wxALIGN_LEFT|wxALL, 5);

    m_sldBaseFreq = new wxSlider;
    m_sldBaseFreq->Create( itemPanel3, ID_SLIDER_BASE_FREQ, 0, 220, 1000, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    m_sldBaseFreq->Show(false);
    itemBoxSizer21->Add(m_sldBaseFreq, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_txtBaseFrequency = new wxStaticText;
    m_txtBaseFrequency->Create( itemPanel3, wxID_STATIC, _("0000"), wxDefaultPosition, wxDefaultSize, 0 );
    m_txtBaseFrequency->Show(false);
    itemBoxSizer21->Add(m_txtBaseFrequency, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText24 = new wxStaticText;
    itemStaticText24->Create( itemPanel3, wxID_STATIC, _("Frequency range"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText24->Show(false);
    itemBoxSizer4->Add(itemStaticText24, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer25 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer4->Add(itemBoxSizer25, 0, wxALIGN_LEFT|wxALL, 5);

    m_sldFreqRange = new wxSlider;
    m_sldFreqRange->Create( itemPanel3, ID_SLIDER_FREQ_RANGE, 0, 50, 3000, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    m_sldFreqRange->Show(false);
    itemBoxSizer25->Add(m_sldFreqRange, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_txtFreqRange = new wxStaticText;
    m_txtFreqRange->Create( itemPanel3, wxID_STATIC, _("0000"), wxDefaultPosition, wxDefaultSize, 0 );
    m_txtFreqRange->Show(false);
    itemBoxSizer25->Add(m_txtFreqRange, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText28 = new wxStaticText;
    itemStaticText28->Create( itemPanel3, wxID_STATIC, _("Background colour"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText28, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    m_clrctrlBackground = new wxColourPickerCtrl;
    m_clrctrlBackground->Create( itemPanel3, ID_COLOURCTRL_BACKGROUND, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    itemBoxSizer4->Add(m_clrctrlBackground, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText30 = new wxStaticText;
    itemStaticText30->Create( itemPanel3, wxID_STATIC, _("Drawing colour"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText30, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    m_clrctrlDrawing = new wxColourPickerCtrl;
    m_clrctrlDrawing->Create( itemPanel3, ID_COLOURCTRL_DRAWING, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    itemBoxSizer4->Add(m_clrctrlDrawing, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    // Connect events and objects
    itemMDIChildFrame1->Connect(ID_BALLONCONFIGURATION, wxEVT_DESTROY, wxWindowDestroyEventHandler(CBallonConfiguration::OnDestroy), NULL, this);
////@end CBallonConfiguration content construction

	m_chkAutoSensitivy->SetValue ( m_activity.GetAutoSensitivy() );
	if (m_activity.GetAutoSensitivy()) m_sldSensitivy->Disable();
	m_timer.Start (250);

//	UpdateShape();

	UpdateStage();	

	m_sldSensitivy->SetValue ( (int) (m_activity.GetSensitivy()) );
	wxCommandEvent evtSensitivy(wxEVT_COMMAND_SLIDER_UPDATED, ID_SLIDER_SENSITIVY);
	GetEventHandler()->ProcessEvent( evtSensitivy );

	m_sldSmoothing->SetValue ( (int) (m_activity.GetSmoothing() * 100.0f) );
	wxCommandEvent evtSmoothing(wxEVT_COMMAND_SLIDER_UPDATED, ID_SLIDER_SMOOTHING);
	GetEventHandler()->ProcessEvent( evtSmoothing );

	m_sldBaseFreq->SetValue ( (int) (m_activity.GetBaseFreq()) );
	wxCommandEvent evtBaseFreq(wxEVT_COMMAND_SLIDER_UPDATED, ID_SLIDER_BASE_FREQ);
	GetEventHandler()->ProcessEvent( evtBaseFreq );

	m_sldFreqRange->SetValue ( (int) (m_activity.GetFreqRange()) );
	wxCommandEvent evtFreqRange(wxEVT_COMMAND_SLIDER_UPDATED, ID_SLIDER_FREQ_RANGE);
	GetEventHandler()->ProcessEvent( evtFreqRange );

	unsigned char red, green, blue, alpha;
	wxColour col;
	m_activity.GetBackgroundColour (red, green, blue, alpha);
	col.Set (red, green, blue, alpha);
	m_clrctrlBackground->SetColour (col);

	m_activity.GetDrawingColour (red, green, blue, alpha);
	col.Set (red, green, blue, alpha);
	m_clrctrlDrawing->SetColour (col);

	m_activity.Run();
}


void CBallonConfiguration::UpdateStage()
{
	wxString str;
	str.Printf(_T("%d"), m_activity.GetCurrentStage());
	m_txtCurrentStage->ChangeValue ( str );
}

void CBallonConfiguration::UpdateShape()
{
	/*
	wxString str;
	str.Printf(_T("%d"), m_activity.GetCurrentShape());
	m_txtCurrentShape->ChangeValue ( str );
	*/
}

void CBallonConfiguration::OnTimer(wxTimerEvent& event)
{
	m_sldSensitivy->SetValue ( (int) (m_activity.GetSensitivy()) );
	wxCommandEvent evtSensitivy(wxEVT_COMMAND_SLIDER_UPDATED, ID_SLIDER_SENSITIVY);
	GetEventHandler()->ProcessEvent( evtSensitivy );
}


/*!
 * wxEVT_CLOSE_WINDOW event handler for ID_BALLONCONFIGURATION
 */

void CBallonConfiguration::OnCloseWindow( wxCloseEvent& event )
{
	//Show (false);
	m_activity.Finish();
	Destroy();
    event.Skip(false);
}

/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_SENSITIVY
 */

void CBallonConfiguration::OnSliderSensitivyUpdated( wxCommandEvent& event )
{
	float val= (float) m_sldSensitivy->GetValue();
	wxString str;
	str.Printf (_T("%.1f"), val);
	m_txtSensitivy->SetLabel (str);
	m_activity.SetSensitivy(val);
    event.Skip(false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_SMOOTHING
 */

void CBallonConfiguration::OnSliderSmoothingUpdated( wxCommandEvent& event )
{
	float val= (float) m_sldSmoothing->GetValue() / 100.0f;
	wxString str;
	str.Printf (_T("%.2f"), val);
	m_txtSmoothing->SetLabel (str);
	m_activity.SetSmoothing(val);
    event.Skip(false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_BASE_FREQ
 */

void CBallonConfiguration::OnSliderBaseFreqUpdated( wxCommandEvent& event )
{
	float val= (float) m_sldBaseFreq->GetValue();
	wxString str;
	str.Printf (_T("%.0f"), val);
	m_txtBaseFrequency->SetLabel (str);
	m_activity.SetBaseFreq(val);
    event.Skip(false);
}




/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_FREQ_RANGE
 */

void CBallonConfiguration::OnSliderFreqRangeUpdated( wxCommandEvent& event )
{
	float val= (float) m_sldFreqRange->GetValue();
	wxString str;
	str.Printf (_T("%.0f"), val);
	m_txtFreqRange->SetLabel (str);
	m_activity.SetFreqRange(val);
    event.Skip(false);
}


/*!
 * wxEVT_COLOURPICKER_CHANGED event handler for ID_COLOURCTRL_BACKGROUND
 */

void CBallonConfiguration::OnColourctrlBackgroundColourPickerChanged( wxColourPickerEvent& event )
{
	wxColour col= event.GetColour();
	m_activity.SetBackgroundColour (col.Red(), col.Green(), col.Blue(), col.Alpha());
    event.Skip(false);
}


/*!
 * wxEVT_COLOURPICKER_CHANGED event handler for ID_COLOURCTRL_DRAWING
 */

void CBallonConfiguration::OnColourctrlDrawingColourPickerChanged( wxColourPickerEvent& event )
{
	wxColour col= event.GetColour();
	m_activity.SetDrawingColour (col.Red(), col.Green(), col.Blue(), col.Alpha());
    event.Skip(false);
}


/*!
 * Should we show tooltips?
 */

bool CBallonConfiguration::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CBallonConfiguration::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CBallonConfiguration bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CBallonConfiguration bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CBallonConfiguration::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CBallonConfiguration icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CBallonConfiguration icon retrieval
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX
 */

void CBallonConfiguration::OnCheckboxAutosensitivyClick( wxCommandEvent& event )
{
	bool new_status= !m_activity.GetAutoSensitivy();
	m_activity.SetAutoSensitivy(new_status);
	//m_chkAutoSensitivy->SetValue ( new_status );
	if (new_status) 
	{
		m_sldSensitivy->Disable();
		m_timer.Start (250);
	}
	else 
	{
		m_sldSensitivy->Enable();
		m_timer.Stop();
	}

	event.Skip(false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON
 */

void CBallonConfiguration::OnButtonPreviousStageClick( wxCommandEvent& event )
{
	m_activity.SetPreviousStage();
	UpdateStage();
    event.Skip(false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON1
 */

void CBallonConfiguration::OnButtonNextStageClick( wxCommandEvent& event )
{
	m_activity.SetNextStage();
	UpdateStage();
    event.Skip(false);
}


/*!
 * wxEVT_DESTROY event handler for ID_BALLONCONFIGURATION
 */

void CBallonConfiguration::OnDestroy( wxWindowDestroyEvent& event )
{
	


//	m_activity.Wait();
//	delete m_activity;
//	m_activity= NULL;
    event.Skip(false);
}

