/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#ifndef _CAMERACONFIGURATION_H_
#define _CAMERACONFIGURATION_H_


/*!
 * Includes
 */

////@begin includes
////@end includes
#include <wx/timer.h>
#include "camwindow2.h"
#include "cameracontroller.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class CCamWindow2;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CCAMERACONFIGURATION 10060
#define ID_PANEL_CAMERA 10061
#define wxID_STATIC_CAMERA_NAME 10062
#define wxID_STATIC_CAMERA_FORMAT 10067
#define ID_BUTTON_CHANGE_CAMERA 10063
#define ID_BUTTON_PROPERTIES 10064
#define ID_BUTTON_CLOSE_CCONFIG 10065
#define SYMBOL_CCAMERACONFIGURATION_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CCAMERACONFIGURATION_TITLE _("Camera Configuration")
#define SYMBOL_CCAMERACONFIGURATION_IDNAME ID_CCAMERACONFIGURATION
#define SYMBOL_CCAMERACONFIGURATION_SIZE wxSize(400, 300)
#define SYMBOL_CCAMERACONFIGURATION_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CCameraConfiguration class declaration
 */

class CCameraConfiguration: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CCameraConfiguration )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCameraConfiguration();
    CCameraConfiguration( wxWindow* parent, wxWindowID id = SYMBOL_CCAMERACONFIGURATION_IDNAME, const wxString& caption = SYMBOL_CCAMERACONFIGURATION_TITLE, const wxPoint& pos = SYMBOL_CCAMERACONFIGURATION_POSITION, const wxSize& size = SYMBOL_CCAMERACONFIGURATION_SIZE, long style = SYMBOL_CCAMERACONFIGURATION_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCAMERACONFIGURATION_IDNAME, const wxString& caption = SYMBOL_CCAMERACONFIGURATION_TITLE, const wxPoint& pos = SYMBOL_CCAMERACONFIGURATION_POSITION, const wxSize& size = SYMBOL_CCAMERACONFIGURATION_SIZE, long style = SYMBOL_CCAMERACONFIGURATION_STYLE );

//	void Create2 ( CCameraController* cController );

	int ShowModal();

    /// Destructor
    virtual ~CCameraConfiguration();

private:


    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CCameraConfiguration event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_CCAMERACONFIGURATION
    void OnCloseWindow( wxCloseEvent& event );

    /// wxEVT_DESTROY event handler for ID_CCAMERACONFIGURATION
    void OnDestroy( wxWindowDestroyEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CHANGE_CAMERA
    void OnButtonChangeCameraClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_PROPERTIES
    void OnButtonPropertiesClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CLOSE_CCONFIG
    void OnButtonCloseCconfigClick( wxCommandEvent& event );

////@end CCameraConfiguration event handler declarations

	void OnTimer(wxTimerEvent& event);

////@begin CCameraConfiguration member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCameraConfiguration member function declarations

	void StartStreaming();

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CCameraConfiguration member variables
    CCamWindow2* m_camPanel;
    wxStaticText* m_txtCameraName;
    wxStaticText* m_txtCameraFormat;
////@end CCameraConfiguration member variables
//	CCameraController* m_cController;
	CCameraDrawer* m_cameraDrawer;

	wxTimer m_timer;
	bool m_openCameraSettings;
};

#endif
    // _CAMERACONFIGURATION_H_
