/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
#pragma once

#include <SDL.h>

class CSDLController
{
private:
	static CSDLController* getInstance(); 
	
	CSDLController();
	~CSDLController();

	// Tells controller that a new drawer wants to access screen.
	// Return the SDL surface to draw (and starts SDL accordingly)
	// or NULL if another background drawer is already registered.
    SDL_Surface *RegisterBackgroundDrawer();
	void UnregisterBackgroundDrawer();

	// Tells controller that background drawer has finished its job
	// to draw to screen and manage events
	void BackgroundFinishedDrawing(SDL_Surface *surface);

	//////////////// TODO //////////////////////////////////////////
	// To support a bg drawer and multiple fg drawers
	// RegisterForegroundDrawer();
	// void UnregisterForegroundDrawer();
	// void ForegroundFinishedDrawing();
	//////////////// TODO //////////////////////////////////////////

/// PRIVATE ///

	void Close();

	// Attributes
	static CSDLController* m_single;
	//SDL_Surface *m_screen;
	bool m_bgDrawerRegistered;
	
	friend class CSDLBackgroundDrawer;
};

class CSDLBackgroundDrawer
{
public:
	CSDLBackgroundDrawer();
	~CSDLBackgroundDrawer();
	SDL_Surface *GetSurface();
	void FinishedDrawing();
	void Close();
private:
	SDL_Surface *m_surface;
};
